unit Cyto;
{$mode delphi}
interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Menus, StdCtrls, ComCtrls, GR32_Image, FormGraphe;

type

  { TFCyto }

  TFCyto = class(TForm)
    CheckBitsInv: TCheckBox;
    ImageFond: TImage32;
    Label1: TLabel;
    MainMenu: TMainMenu;
    MAPropos: TMenuItem;
    MenuItem1: TMenuItem;
    MQuitter: TMenuItem;
    MFichier: TMenuItem;
    OpenDialog: TOpenDialog;
    MOuvrir: TMenuItem;
    PanChoixOrdreBits: TPanel;
    PanFichier: TPanel;
    MDonnees: TMenuItem;
    MAjouter: TMenuItem;
    MGraphique: TMenuItem;
    MNouvGraph: TMenuItem;
    MAffichGraph: TMenuItem;
    MCategories: TMenuItem;
    MStats: TMenuItem;
    MCatEdit: TMenuItem;
    MCatAff: TMenuItem;
    MCatCompNouv: TMenuItem;
    ProgressBar: TProgressBar;
    SaveDialog1: TSaveDialog;
    PPatienter: TPanel;
    MParametres: TMenuItem;
    procedure CheckBitsInvChange(Sender: TObject);
    procedure ImageFondKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MAProposClick(Sender: TObject);
    procedure MOuvrirClick(Sender: TObject);
    procedure MDonneesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MNouvGraphClick(Sender: TObject);
    procedure MCategoriesClick(Sender: TObject);
    procedure MQuitterClick(Sender: TObject);
    procedure MStatsClick(Sender: TObject);
    procedure MParametresClick(Sender: TObject);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    Graphiques : Array of TFGraphe;
    NbGraphes : integer;
    PlusieursJeux : Boolean;
    IndexDefaut : integer;
    ModeProf : Boolean;
    procedure MGraphiClick(Sender: TObject);
    procedure CatChange(Sender : TObject);
    procedure RecenceRestrictions(Sender : TObject);
    procedure CreeGraphiqueParDefaut;
  end;

var
  FCyto: TFCyto;

implementation

{$R *.lfm}
uses Donnees,FMemo,FormChoixCat,FormStats,FormParams,gestionFichier,formapropos; //FCSLibrary


procedure TFCyto.FormCreate(Sender: TObject);
begin
  MargeG := 50;
  MargeD := 20;
  MargeH := 20;
  MargeB :=40;
  NbGraphes := 0;
  ModeProf := False;
  LesCategories := TEnsembleCategories.Create;
  LesCategories.NbCategorieDeBase := 0;
  LesCategories.NbCategorieComp := 0;
  PlusieursJeux := False;
  IndexDefaut :=0;
  if FileExists('ImageFond.jpg') then
    ImageFond.Bitmap.LoadFromFile('ImageFond.jpg');
end;
procedure TFCyto.RecenceRestrictions(Sender : TObject);
Var
  i,j,n:integer;
  UneCat : TCategorie;
  Nouveau : Boolean;
begin
  SetLength(FChoixcat.LesRestrictions,0);
  for i := 0 to NbGraphes - 1 do
    begin
      UneCat := Graphiques[i].CatRestr;
      if UneCat <> nil then
        begin
          Nouveau := True;
          n := Length(FChoixcat.LesRestrictions);
          for j:=0 to n - 1 do
            if UneCat = FChoixcat.LesRestrictions[j] then
              begin
                Nouveau := False;
                Break;
              end;
          if Nouveau then
            begin
              SetLength(FChoixcat.LesRestrictions,n+1);
              FChoixcat.LesRestrictions[n]:= UneCat;
            end;
        end;
    end;
end;

procedure TFCyto.MCategoriesClick(Sender: TObject);
Var
  LeMenu : TMenuItem;
begin
  LeMenu := (Sender as TMenuItem);
  if LeMenu <> nil then
    begin
      if LeMenu.Tag = 0 then
        begin
          FChoixCat.initialise(ecConsult);
          FChoixCat.Show;
        end
      else if LeMenu.Tag = 1 then
        begin
          FChoixCat.initialise(ecEditSimple);
          if FChoixCat.ShowModal = mrOk then
            CatChange(nil);
        end
      else
        begin
          FChoixCat.initialise(ecAjoutComp);
          if FChoixCat.ShowModal = mrOk then
            CatChange(nil);
        end;
    end;
end;

procedure TFCyto.MQuitterClick(Sender: TObject);
begin
  Close;
end;

procedure TFCyto.CatChange(Sender : TObject);
Var
  i,j : integer;
  UnMenuItem : TMenuItem;
  NomCatCochee : string;
begin
  for i := 0 to NbGraphes - 1 do
    begin
      // Rechercher si une categorie est cochée
      NomCatCochee := '';
      for j := 0 to Graphiques[i].MRestreindre.Count - 1 do
        if Graphiques[i].MRestreindre.Items[j].Checked then
          begin
            NomCatCochee := Graphiques[i].MRestreindre.Items[j].Caption;
            Break;
          end;
      Graphiques[i].MRestreindre.Clear;
      //construire les sous-menus de MRestreindre en conservant cochée la categorie cochée
      for j := 0 to LesCategories.NbCategorieDeBase -1 do
        begin
          UnMenuItem := TMenuItem.Create(Graphiques[i].MRestreindre);
          UnMenuItem.Caption:=LesCategories.LesCategoriesDeBase[j].Nom;
          if LesCategories.LesCategoriesDeBase[j].AncienNom = '' then
            UnMenuItem.Checked:=(UnMenuItem.Caption = NomCatCochee)
          else
            UnMenuItem.Checked:=(LesCategories.LesCategoriesDeBase[j].AncienNom = NomCatCochee);
          UnMenuItem.Tag:=j;
          UnMenuItem.OnClick:=Graphiques[i].MRestreindreClick;
          Graphiques[i].MRestreindre.Add(UnMenuItem);
        end;
      for j := 0 to LesCategories.NbCategorieComp -1 do
        begin
          UnMenuItem := TMenuItem.Create(Graphiques[i].MRestreindre);
          UnMenuItem.Caption:=LesCategories.LesCategoriesComp[j].Nom;
          if LesCategories.LesCategoriesComp[j].AncienNom = '' then
            UnMenuItem.Checked:=(UnMenuItem.Caption = NomCatCochee)
          else
            UnMenuItem.Checked:=(LesCategories.LesCategoriesComp[j].AncienNom = NomCatCochee);
          UnMenuItem.Tag:=-2-j;
          UnMenuItem.OnClick:=Graphiques[i].MRestreindreClick;
          Graphiques[i].MRestreindre.Add(UnMenuItem);
        end;
      Graphiques[i].MRestreindre.Visible:=(Graphiques[i].MRestreindre.Count > 0);
      Graphiques[i].TraceGraphe;
    end;
  FParams.MRestreindre.Clear;
  //construire les sous-menus de MRestreindre en conservant cochée la categorie cochée
  for j := 0 to LesCategories.NbCategorieDeBase -1 do
    begin
      UnMenuItem := TMenuItem.Create(FParams.MRestreindre);
      UnMenuItem.Caption:=LesCategories.LesCategoriesDeBase[j].Nom;
      UnMenuItem.Checked:=False;
      UnMenuItem.Tag:=j;
      UnMenuItem.OnClick:=FParams.MRestreindreClick;
      FParams.MRestreindre.Add(UnMenuItem);
    end;
  for j := 0 to LesCategories.NbCategorieComp -1 do
    begin
      UnMenuItem := TMenuItem.Create(FParams.MRestreindre);
      UnMenuItem.Caption:=LesCategories.LesCategoriesComp[j].Nom;
      UnMenuItem.Checked:=False;
      UnMenuItem.Tag:=-2-j;
      UnMenuItem.OnClick:=FParams.MRestreindreClick;
      FParams.MRestreindre.Add(UnMenuItem);
    end;
  FParams.MRestreindre.Visible:=(FParams.MRestreindre.Count > 0);
end;

procedure TFCyto.MDonneesClick(Sender: TObject);
Var
  i: integer;
begin
if Length(LesDonneesCyto) > 0 then
  begin
    FDonnees.ComboFichier.Items.Clear;
    for i := 0 to Length(LesDonneesCyto) - 1 do
      FDonnees.ComboFichier.Items.Add(LesDonneesCyto[i].Nom);
    FDonnees.Show;
  end;
end;
procedure TFCyto.MGraphiClick(Sender: TObject);
Var
  i : integer;
begin
  i := (Sender as TMenuItem).Tag;
  if i < Length(Graphiques) then
    begin
      Graphiques[i].WindowState:=wsNormal;
      Graphiques[i].Show;
      Graphiques[i].BringToFront;
    end;
end;
procedure TFCyto.MNouvGraphClick(Sender: TObject);
Var
  NouvGraph : TFGraphe;
  DernDonneeCyto : TDonneesCyto;
  i : integer;
  UnMenuItem : TMenuItem;
  Nm, MonMessage : string;
begin
  if Length(LesDonneesCyto) > 0 then
    begin
      NouvGraph := TFGraphe.Create(Application);
      NouvGraph.Parent := nil;
      NouvGraph.OnCatChange := CatChange;
      NouvGraph.RecenceRestr := RecenceRestrictions;
      NouvGraph.Name := 'Graphe'+IntToStr(NbGraphes);
      //NouvGraph.Parent := Self;
      NouvGraph.ComboFichiers.Items.Clear;
      for i := 0 to Length(LesDonneesCyto)-1 do
        NouvGraph.ComboFichiers.Items.AddObject(LesDonneesCyto[i].Nom,LesDonneesCyto[i]);
      DernDonneeCyto := LesDonneesCyto[Length(LesDonneesCyto)-1];
      NouvGraph.MesDonneesCyto:=DernDonneeCyto;
      NouvGraph.ComboFichiers.ItemIndex:=Length(LesDonneesCyto)-1;
      //NouvGraph.ComboFichiers.Items.AddObject(DernDonneeCyto.Nom,DernDonneeCyto);
      if PlusieursJeux then
        NouvGraph.ComboFichiers.ItemIndex := IndexDefaut
      else
        NouvGraph.ComboFichiers.ItemIndex := NouvGraph.ComboFichiers.Items.Count - 1;
      PlusieursJeux := False;
      NouvGraph.NumSerie := NouvGraph.ComboFichiers.ItemIndex;
      NouvGraph.Caption := 'Graphique '+IntToStr(NbGraphes+1)+' - Fichier : '+ NouvGraph.ComboFichiers.Items[NouvGraph.NumSerie];
      NouvGraph.ComboParam1.Items.Clear;
      NouvGraph.ComboParam2.Items.Clear;
      NouvGraph.ComboParam2.Items.Add('(Histogramme)');
      For i :=0 to DernDonneeCyto.NbParam -1 do
        begin
          Nm := DernDonneeCyto.Parametres[i].Alias;
          if Trim(Nm) = '' then
            Nm := DernDonneeCyto.Parametres[i].Nom;
          NouvGraph.ComboParam1.Items.AddObject(Nm,DernDonneeCyto.Parametres[i]);
          NouvGraph.ComboParam2.Items.AddObject(Nm,DernDonneeCyto.Parametres[i]);
        end;
      SetLength(Graphiques,NbGraphes+1);
      Graphiques[NbGraphes] := NouvGraph;
      inc(NbGraphes);
      NouvGraph.Nom :='Graphe '+IntToStr(NbGraphes);
      for i := 0 to LesCategories.NbCategorieDeBase -1 do
        begin
          UnMenuItem := TMenuItem.Create(NouvGraph.MRestreindre);
          UnMenuItem.Caption:=LesCategories.LesCategoriesDeBase[i].Nom;
          UnMenuItem.Checked:=False;
          UnMenuItem.Tag:=i;
          UnMenuItem.OnClick:=NouvGraph.MRestreindreClick;
          NouvGraph.MRestreindre.Add(UnMenuItem);
       end;
      for i := 0 to LesCategories.NbCategorieComp -1 do
        begin
          UnMenuItem := TMenuItem.Create(NouvGraph.MRestreindre);
          UnMenuItem.Caption:=LesCategories.LesCategoriesComp[i].Nom;
          UnMenuItem.Checked:=False;
          UnMenuItem.Tag:=-2-i;
          UnMenuItem.OnClick:=NouvGraph.MRestreindreClick;
          NouvGraph.MRestreindre.Add(UnMenuItem);
        end;
      NouvGraph.MRestreindre.Visible:=(NouvGraph.MRestreindre.Count > 0);
      if LesCategories.NbCategorieDeBase > 0 then
        NouvGraph.MAfCategorie.Checked:=True
      else
        NouvGraph.MAfDensite.Checked:=True;
      NouvGraph.ComboFichiersChange(nil);
      NouvGraph.CheckCorr.Visible:=ModeProf;
      NouvGraph.Show;
      UnMenuItem := TMenuItem.Create(MAffichGraph);
      UnMenuItem.Caption:=NouvGraph.Nom;
      UnMenuItem.Tag := NbGraphes - 1;
      UnMenuItem.OnClick := MGraphiClick;
      MAffichGraph.Add(UnMenuItem);
      MAffichGraph.Enabled:=True;
    end
  else
    begin
      MonMessage := 'il n''y a pas encore de données chargées';
      MessageDlg(MonMessage,TMsgDlgType.mtError,[TMsgDlgBtn.mbOK],0);
    end;
end;

procedure TFCyto.MOuvrirClick(Sender: TObject);
Var
  i,j,n : integer;
  //Nm : string;
  Ajouter : Boolean;
  DernDonneeCyto : TDonneesCyto;
  MonMessage : Array of string;
  //UnMenuItem : TMenuItem;
  FCS : TFCSFile;
  OnePercent : integer;
  LaDonneeCyto : TDonneesCyto;
  LaLigneDonnees : TLigneDonnees;
  UnParam : TParam;
  NomFichier : string;
  NomComplet : AnSiString;
begin
  if OpenDialog.Execute then
    begin
      ChangeOrdreBitsDefaut(CheckBitsInv.Checked);
      NomFichier := ExtractFileName(OpenDialog.FileName);
      Ajouter := ((Sender as TComponent).Tag = 1);
      if (not Ajouter) and (Length(LesDonneesCyto)>0) then
        begin
{          SetLength(MonMessage,1);
          MonMessage[0] :='Voulez-vous effacer toutes les données déjà chargées et les graphiques réalisés ?';
          //if MessageDlg(MonMessage,mtConfirmation,[mbYes,mbNo],0)= mrYes then
          if MessageOuiNon(MonMessage) = mrYes then
            begin }
              for i := 0 to Length(Graphiques) - 1 do
                Graphiques[i].Free;
              SetLength(Graphiques,0);
              NbGraphes :=0;
              MAffichGraph.Clear;
              for i := 0 to Length(LesDonneesCyto) - 1 do
                LesDonneesCyto[i].Free;
              SetLength(LesDonneesCyto,0);
              FChoixcat.RAZ;
              LesCategories.Raz;
              RazParametres;
              //** Remettre à zéro les Catégories de FormChoixCat
{            end
          else
            Ajouter := True;}
        end;
      Screen.Cursor:=crHourGlass;
      Application.ProcessMessages;
      NomComplet := UTF8ToAnsi(OpenDialog.Filename);
      FCS := TFCSFile.Create(NomComplet);
      try
        if FCS.LitJeuDonnees then
          begin
            IndexDefaut := Length(LesDonneesCyto)-1;
            While (FCS.FNextData>0) and (FCS.FFileStream.Position < FCS.FFileStream.Size) do
              begin
                VerifieParametres;
                PlusieursJeux := True;
                FCS.OffsetGen:=FCS.OffsetGen+FCS.FNextData;
                FCS.LitJeuDonnees;
              end;
          end;
      finally
        FCS.Free;
      end;
      if Length(LesDonneesCyto) > 0 then
        begin
          VerifieParametres;
          DernDonneeCyto := LesDonneesCyto[Length(LesDonneesCyto)-1];
          DernDonneeCyto.NomFichier:=NomFichier;
          if Trim(DernDonneeCyto.Nom) = '' then
            DernDonneeCyto.Nom := NomFichier;
          Caption := 'Cytométrie';
          if DernDonneeCyto.Projet <> '' then
            Caption := Caption + ' - Projet : '+DernDonneeCyto.Projet;
          if DernDonneeCyto.Cellules <> '' then
            Caption := Caption + ' - Cellules étudiées : '+DernDonneeCyto.Cellules;
          PanFichier.Caption := '    Données chargées : ';
          for i := 0 to Length(LesDonneesCyto)-1 do
            begin
              if i > 0 then
                PanFichier.Caption := PanFichier.Caption + ', ';
              PanFichier.Caption := PanFichier.Caption + LesDonneesCyto[i].Nom;  //Fichier
            end;
          for j := 0 to Length(Graphiques) - 1 do
            Graphiques[j].ComboFichiers.Items.AddObject(DernDonneeCyto.Nom,DernDonneeCyto);
          CreeGraphiqueParDefaut;
        end;
      ProgressBar.Visible:=False;
      Screen.Cursor:=crDefault;
    end;
end;

procedure TFCyto.MAProposClick(Sender: TObject);
begin
  FAPropos.ShowModal;
end;

procedure TFCyto.ImageFondKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift) and (Key = 80) then
    begin
      MDonnees.Visible:=True;
      MParametres.Visible:=True;
      ModeProf := True;
      PanChoixOrdreBits.Visible:=True;
      Application.ProcessMessages;
    end;
  //else
    //PanFichier.Caption:=IntToStr(Key);

end;

procedure TFCyto.CheckBitsInvChange(Sender: TObject);
begin
  ChangeOrdreBitsDefaut(CheckBitsInv.Checked);
end;

procedure TFCyto.CreeGraphiqueParDefaut;
Var
  i,n : integer;
  NouvGraph : TFGraphe;
begin
  MNouvGraphClick(nil);
  NouvGraph := Graphiques[NbGraphes-1];
  NouvGraph.ParDefaut;
end;

procedure TFCyto.MParametresClick(Sender: TObject);
Var
  i : integer;
begin
  if FParams.initialise then
    FParams.ShowModal;
  //** s'il y a plusieurs fichiers, vérifier s'il n'y a pas des paramètres à unifier
  // réajuster les graphiques si modif des Alias
    if FParams.AChange then
      begin
        for i := 0 to  Length(Graphiques) - 1 do
          begin
            Graphiques[i].TraceGraphe;
          end;
      end;
end;

procedure TFCyto.MStatsClick(Sender: TObject);
begin
  FStats.CatRestr := nil;
  FStats.AfficheStats;
  FStats.Show;
end;

end.
