unit FormGraphe;
{$mode delphi}
interface

uses
  Classes, SysUtils, FileUtil, PrintersDlgs, Forms, Controls, Graphics, GR32,
  GR32_Image, GR32_Polygons,GR32_Layers, Dialogs, ExtCtrls, Menus, StdCtrls, Donnees;
  
type

  { TFGraphe }

  TFGraphe = class(TForm)
    CheckCorr: TCheckBox;
    Dessin: TImage32;
    MenuItem1: TMenuItem;
    MAugmenter: TMenuItem;
    MDiminuer: TMenuItem;
    MenuItem2: TMenuItem;
    MAfCouleur: TMenuItem;
    MAfCategorie: TMenuItem;
    MAfDensite: TMenuItem;
    MRestreindre: TMenuItem;
    MlogY: TMenuItem;
    MLogX: TMenuItem;
    MSurDessus: TMenuItem;
    PChoix: TPanel;
    ComboParam1: TComboBox;
    ComboParam2: TComboBox;
    ComboFichiers: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LCurseur: TLabel;
    LCat: TLabel;
    MainMenu1: TMainMenu;
    MEdition: TMenuItem;
    MCategories: TMenuItem;
    MAffichage: TMenuItem;
    MEditerCat: TMenuItem;
    MAjouterCat: TMenuItem;
    MCopier: TMenuItem;
    MTaillePoints: TMenuItem;
    MPointPlus: TMenuItem;
    MPointMoins: TMenuItem;
    MChoix: TMenuItem;
    PInfos: TPanel;
    PInstruct: TPanel;
    LInstructCat: TLabel;
    MAjoutComp: TMenuItem;
    MEnregistrer: TMenuItem;
    SaveDialogGraphe: TSaveDialog;
    MAffCat: TMenuItem;
    PChoixTitre: TPanel;
    EdiTitre: TEdit;
    BOKTitre: TButton;
    MChoixtitre: TMenuItem;
    MFichier: TMenuItem;
    MImprimer: TMenuItem;
    MFermer: TMenuItem;
    MStats: TMenuItem;
    procedure CheckCorrChange(Sender: TObject);
    procedure ComboParamChange(Sender: TObject);
    procedure ComboFichiersChange(Sender: TObject);
    procedure DessinMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MAjouterCatClick(Sender: TObject);
    procedure MAugmenterClick(Sender: TObject);
    procedure MCouleurClick(Sender: TObject);
    procedure MDiminuerClick(Sender: TObject);
    procedure MLogClick(Sender: TObject);
    procedure MPointMoinsClick(Sender: TObject);
    procedure MPointPlusClick(Sender: TObject);
    procedure MEditerCatClick(Sender: TObject);
    procedure MChoixClick(Sender: TObject);
    procedure MCopierClick(Sender: TObject);
    procedure MAjoutCompClick(Sender: TObject);
    procedure MEnregistrerClick(Sender: TObject);
    procedure MAffCatClick(Sender: TObject);
    procedure BOKTitreClick(Sender: TObject);
    procedure MChoixtitreClick(Sender: TObject);
    procedure DessinMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer; Layer: TCustomLayer);
    procedure DessinMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: integer; Layer: TCustomLayer);
    procedure MFermerClick(Sender: TObject);
    procedure MImprimerClick(Sender: TObject);
    procedure MStatsClick(Sender: TObject);
    procedure MSurDessusClick(Sender: TObject);
    procedure MRestreindreClick(Sender : TObject);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    NumSerie : integer;
    RectGraphe : TRect;
    Polygone : TPolygon32;
    //MesPolygones : Array of TPolygon32;
    FinTrace: Boolean;
    TraceEnCours : Boolean;
    Nom : string;
    LeParam1,LeParam2 : TParam;
    coefX,CoefY : real;
    MesDonneesCyto : TDonneesCyto;
    //MonBitMapTest : TBitmapTest;
    Inverser : Boolean;
    XM0,YM0,XM1 : integer;
    Taillepoints : integer;
    Titre : string;
    CoucheProv : TBitmapLayer;
    SupportLegende : TRubberbandLayer;
    legende : TBitmapLayer;
    MaxiAxeX,MaxiAxeY : real;
    MiniAxeX,MiniAxeY : real;
    OnCatChange : TNotifyEvent;
    RecenceRestr : TNotifyEvent;
    CatRestr : TCategorie;
    CatActive : Array of Boolean;
    procedure TraceGraphe;
    procedure DessineLegende;
    procedure Montre;
    function BitmapCopie : TBitmap32;
    procedure ParDefaut;
  end;

var
  FGraphe: TFGraphe;

implementation
uses FormChoixCat,Math,Gestimpr,FormStats,Clipbrd;
{$R *.lfm}

procedure TFGraphe.ParDefaut;
Var
  i, n : integer;

begin
  n := MesDonneesCyto.NumParamTaille;
  if n > -1 then
    begin
      ComboParam1.ItemIndex:=n;
      n := MesDonneesCyto.NumParamComplexite;
      if n > -1 then
        begin
          ComboParam2.ItemIndex:=n+1;
          ComboParamChange(nil);
        end;
    end;
end;

procedure TFGraphe.MRestreindreClick(Sender : TObject);
Var
  LeMenu : TMenuItem;
  n,i : integer;
begin
  LeMenu := TMenuItem(Sender);
  if LeMenu <> nil then
    begin
      LeMenu.Checked:= Not LeMenu.Checked;
      if (NumSerie > -1) and (NumSerie < ComboFichiers.Items.Count) then
        Caption := 'Graphique - Fichier : '+ ComboFichiers.Items[NumSerie];
      if LeMenu.Checked then
        begin
          n := LeMenu.Tag;
          if n <-1 then
            CatRestr := LesCategories.LesCategoriesComp[-2-n]
          else if n > -1 then
            CatRestr := LesCategories.LesCategoriesDeBase[n];
          for i := 0 to MRestreindre.Count - 1 do
            if MRestreindre.Items[i]<>LeMenu then
              MRestreindre.Items[i].Checked:=False;
          Caption := Caption + ' Affichage limité à la catégorie '+ CatRestr.Nom;
        end
      else
        CatRestr := nil;
    end;
  //ComboParamChange(ComboParam1);
  TraceGraphe;
  PChoix.Visible := True;
  MChoix.Caption := 'Curseur et informations';
  PInfos.Visible := False;
end;
procedure TFGraphe.Montre;
begin
  Activate;
  BringToFront;
  if (NumSerie > -1) and (NumSerie < ComboFichiers.Items.Count) then
    Caption := 'Graphique - Fichier : '+ ComboFichiers.Items[NumSerie];
end;
procedure TFGraphe.BOKTitreClick(Sender: TObject);
begin
  Titre := Edititre.Text;
  PChoixTitre.Visible := False;
  PInfos.Visible := True;
  PChoix.Visible := False;
  MChoix.Caption := 'Choix des paramètres';
  TraceGraphe;
end;

procedure TFGraphe.ComboFichiersChange(Sender: TObject);
Var
  i : integer;
  ip2 : integer;
  NParam1,NParam2: string;
  Nm : string;
begin
  ip2 := -1;
  NParam1 := '';
  NParam2 := '';
  NumSerie := ComboFichiers.ItemIndex;
  MesDonneesCyto :=(ComboFichiers.Items.Objects[NumSerie] as TDonneesCyto);
  if MesDonneesCyto <> Nil then
    begin
      if ComboParam1.ItemIndex > -1 then
        begin
          NParam1 := UpperCase(ComboParam1.Text);
          ip2 := ComboParam2.ItemIndex;
          if ip2 = -1 then
            ip2 := 0;
          if ip2 > 0 then
            NParam2 := UpperCase(ComboParam2.Text);
        end;
      ComboParam1.Items.Clear;
      ComboParam2.Items.Clear;
      ComboParam2.Items.Add('(Histogramme)');
      For i :=0 to MesDonneesCyto.NbParam -1 do
        begin
          Nm := MesDonneesCyto.Parametres[i].Alias;
          if Trim(Nm) = '' then
            Nm := MesDonneesCyto.Parametres[i].Nom;
          ComboParam1.Items.AddObject(Nm,MesDonneesCyto.Parametres[i]);
          ComboParam2.Items.AddObject(Nm,MesDonneesCyto.Parametres[i]);
        end;
      Dessin.Bitmap.Clear($FFFFFFFF);
      Titre := '';
      Legende.Visible := False;
      SupportLegende.Visible:=False;
      Legende.Bitmap.SetSize(0,0);
      MiniAxeX := 0;
      MiniAxeY := 0;
      if (CatRestr <> nil) and (Not Compatible(CatRestr,MesDonneesCyto)) then
        CatRestr := nil;
      Caption := 'Graphique - Fichier : '+ ComboFichiers.Items[NumSerie];
      if ip2 > -1 then
        begin
          ComboParam1.ItemIndex := -1;
          for i := 0 to ComboParam1.Items.Count-1 do
            if UpperCase(ComboParam1.Items[i]) = NParam1 then
              begin
                ComboParam1.ItemIndex := i;
                Break;
              end;
          if ComboParam1.ItemIndex = -1 then
            Pardefaut
          else
            begin
              if ip2 = 0 then
                ComboParam2.ItemIndex := 0
              else
                begin
                  for i := 1 to ComboParam2.Items.Count-1 do
                    if UpperCase(ComboParam2.Items[i]) = NParam2 then
                      begin
                        ComboParam2.ItemIndex := i;
                        Break;
                      end;
                end;
              ComboParamChange(nil);
            end;
        end
      else
        ParDeFaut;
    end;
end;

procedure TFGraphe.DessinMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  LeBitmap : TBitmap32;
  LePoint : TPoint;
   UneCategorie : TCategorie;
begin
  LePoint := Point(X,Y);
  if MAjouterCat.Checked then
    begin
      if (LeParam1 <> Nil) and (LeParam2 <> Nil) then
        begin
          if PtInRect(RectGraphe,LePoint ) then
            begin
              if FinTrace then
                begin
                  Polygone.Clear;
                  Polygone.Closed:=False;
                end;
              Polygone.Add(FixedPoint(LePoint));
              XM0 := X;
              YM0 := Y;
              LeBitmap := CoucheProv.Bitmap;
              LeBitmap.BeginUpdate;
              LeBitmap.Clear($00FFFFFF);
              Polygone.DrawEdge(LeBitmap,Color32(FChoixCat.PanCouleur.Color));
              LeBitmap.EndUpdate;
              CoucheProv.Bitmap.Changed;
              Dessin.Changed;
              if Button = TMouseButton.mbLeft then
                begin
                  FinTrace:=False;
                  TraceEnCours := True;
                end
              else
                begin
                  FinTrace:=True;
                  TraceEnCours := False;
                  Polygone.Closed:=True;
                  CoucheProv.Cursor := CrDefault;
                  LeBitmap := CoucheProv.Bitmap;
                  LeBitmap.BeginUpdate;
                  LeBitmap.Clear($00FFFFFF);
                  Polygone.DrawEdge(LeBitmap,Color32(FChoixCat.PanCouleur.Color));
                  LeBitmap.EndUpdate;
                  CoucheProv.Bitmap.Changed;

                  // Définition de la zone
                  UneCategorie := TCategorie.Create;
                  UneCategorie.Nom := 'Categorie '+ InTToStr(LesCategories.NbCategorieDeBase + 1);
                  UneCategorie.NbParams := 2;
                  SetLength(UneCategorie.Params,2);
                  UneCategorie.Params[0] :=  (ComboParam1.Items.Objects[ComboParam1.ItemIndex] as TPAram);
                  UneCategorie.Params[1] :=  (ComboParam2.Items.Objects[ComboParam2.ItemIndex] as TPAram);
                  UneCategorie.Resolution := UneCategorie.Params[0].Resolution;
                  UneCategorie.Active := True;
                  if CatRestr = nil then       //** faire de même pour histogramme
                    FChoixCat.initialise(ecAjoutSimple)
                  else
                    begin
                      FChoixCat.CatRestr := CatRestr;
                      FChoixCat.initialise(ecAjoutSimpleComp);
                      UneCategorie.CatAnnexe:=True;
                    end;
                  FChoixCat.CatSimpleEnCours := UneCategorie;
                  if FChoixCat.ShowModal= mrOK then
                    begin
                      coefX :=MaxiAxeX/(Dessin.Bitmap.Width-MargeG-MargeD);
                      coefY :=MaxiAxeY/(Dessin.Bitmap.Height-MargeH-MargeB);
                      UneCategorie.PolygoneDef := TransposePolygone(Polygone,coefX,coefY,MaxiAxeY,MLogX.Checked,MLogY.Checked);
                      UneCategorie.Nom := FChoixCat.EditNom.Text;
                      if CatRestr = nil then
                        UneCategorie.Couleur := Color32(FChoixCat.PanCouleur.Color)
                      else
                        UneCategorie.Couleur := Color32(FChoixCat.PanCouleurComp.Color);
                      UneCategorie.Active := True;
                      LesCategories.AjouteDeBase(UneCategorie);

                      FChoixCat.Ajouter;
                      if CatRestr <> nil then
                        begin
                          UneCategorie.CatFille:=LesCategories.LesCategoriesComp[LesCategories.NbCategorieComp-1];
                          if  LesCategories.NbCategorieComp > 1 then
                            MAfCategorie.Checked:=True;
                        end
                      else if LesCategories.NbCategorieDeBase > 1 then
                        MAfCategorie.Checked:=True;

                      TraceGraphe;
                      if Assigned(OnCatChange) then OnCatChange(Self);
                    end
                  else
                    begin
                      UneCategorie.Free;
                      CoucheProv.Bitmap.Clear($00FFFFFF);
                    end;
                  CoucheProv.Visible := False;
                  MAjouterCat.Checked := False;
                  PInstruct.Visible := False;
                  PChoix.Visible := False;
                  PChoixTitre.Visible := False;
                  PInfos.Visible := True;
                end;
            end;
        end
      else if LeParam1 <> Nil then // cas des histogrammes
        begin
          if Fintrace then
            begin
              XM0 := X;
              LeBitmap := CoucheProv.Bitmap;
              LeBitmap.BeginUpdate;
              LeBitmap.Clear($00FFFFFF);
              LeBitmap.VertLineS(X,MargeH,LeBitmap.Height-MargeB-1,Color32(FChoixCat.PanCouleur.Color));  //and $A0FFFFFF
              LeBitmap.EndUpdate;
              CoucheProv.Bitmap.Changed;
              Dessin.Changed;
              FinTrace:=False;
            end;
        end;
    end;
end;

procedure TFGraphe.ComboParamChange(Sender: TObject);
Var
  ind1,ind2:integer;
begin
  ind1 := ComboParam1.ItemIndex;
  Legende.Visible := False;
  SupportLegende.Visible:=False;
  Legende.Bitmap.SetSize(0,0);
  if Ind1 > -1 then
    begin
      Titre := '';
      LeParam1 := (ComboParam1.Items.Objects[Ind1] as TParam);
      ind2 := ComboParam2.ItemIndex;
      if (Ind2 > 0) then
        begin
          LeParam2 := (ComboParam2.Items.Objects[Ind2] as TParam);
        end
      else
        LeParam2 := Nil;
      if LeParam1 <> Nil then
        begin
          MaxiAxeX := 0;
          MaxiAxeY := 0;
          MLogX.Visible:=(Pos('FSC',LeParam1.Nom) = 0) and (Pos('SSC',LeParam1.Nom) = 0) and (LeParam1.Puis10Log = 0) and (LeParam1.Resolution > 10000);
          MLogX.Checked:=MLogX.Visible;
          if MLogX.Checked then
            MiniAxeX := 200
          else
            MiniAxeX := 0;
          if LeParam2 = nil then
            TraceGraphe;
        end;
      if LeParam2 <> nil then
        begin
          MLogY.Visible:=(Pos('FSC',LeParam2.Nom) = 0) and (Pos('SSC',LeParam2.Nom) = 0) and (LeParam2.Puis10Log = 0) and (LeParam2.Resolution > 10000);
          MLogY.Checked:=MLogY.Visible;
          if MLogY.Checked then
            MiniAxeY := 200
          else
            MiniAxeY := 0;
          TraceGraphe;
        end;
    end;
end;

procedure TFGraphe.CheckCorrChange(Sender: TObject);
begin
  ComboParamChange(ComboParam1);
end;

procedure TFGraphe.TraceGraphe;
Var
   i : integer;
  lgt : integer;
  MonPolyg : TPolygon32;
begin
  if LeParam1 <> Nil then
    begin
      //LesBitmapTests.RetraceBitMaps;
      Dessin.Bitmap.Clear($FFFFFFFF);
      CoucheProv.Bitmap.Clear($00FFFFFF);
      FinTrace:=True;
      //coefX :=MesDonneesCyto.Resolution/(Dessin.Bitmap.Width-MargeG-MargeD);
      Dessin.Bitmap.BeginUpdate;
      if Titre <>'' then
        begin
          lgt :=Dessin.Bitmap.TextWidth(Titre);
          //htt := Dessin.Bitmap.TextHeight(Titre);
          Dessin.Bitmap.RenderText(Round((Dessin.Bitmap.Width-lgt)/2),2,Titre,qltt,clBlack32);
        end;
      if LeParam2 <> Nil then
        begin // graphe à 2 dimensions
          MesDonneesCyto.TraceGraphe(Dessin.Bitmap,LeParam1,LeParam2,TaillePoints,MLogX.Checked,MLogY.Checked,CatRestr,MAfDensite.Checked,MaxiAxeX,MaxiAxeY);
          //coefY :=MesDonneesCyto.Resolution/(Dessin.Bitmap.Height-MargeH-MargeB);
          coefY :=(MaxiAxeY-MiniAxeY)/(Dessin.Bitmap.Height-MargeH-MargeB);
          coefX :=(MaxiAxeX-MiniAxeX)/(Dessin.Bitmap.Width-MargeG-MargeD);
          MAugmenter.Visible:=False;
          MDiminuer.Visible:=False;;
        end
      else  // histogramme
        begin
          MesDonneesCyto.TraceHisto(Dessin.Bitmap,LeParam1,MLogX.Checked,CheckCorr.Checked,CatRestr,MaxiAxeX,MaxiAxeY);
          coefY :=(MaxiAxeY-MiniAxeY)/(Dessin.Bitmap.Height-MargeH-MargeB);
          coefX :=(MaxiAxeX-MiniAxeX)/(Dessin.Bitmap.Width-MargeG-MargeD);
          MAugmenter.Visible:=True;
          MDiminuer.Visible:=True;;
        end;
      Dessin.Bitmap.EndUpdate;
      Dessin.Changed;
      Legende.Visible := True;
      DessineLegende;
    end;
end;

procedure TFGraphe.DessinMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer; Layer: TCustomLayer);
Var
  MonPoint : TPoint;
  StrCX,StrCY : string;
  MaCategorie : TCategorie;
  MPX,MPY : real;
  MaCouleur : TColor32;
  LeBitmap : TBitmap32;
  TitreX,TitreY: string;
  larg,NbGX : integer;
  Vmax,dx : real;
  VX : real;
  MonPointC : TPoint;
begin
  if MAjouterCat.Checked then
    begin
      if (Not FinTrace) and (ssLeft in Shift) and (LeParam1 <> Nil) and (LeParam2 = Nil) then
        begin
          XM1 := X;
          LeBitmap := CoucheProv.Bitmap;
          LeBitmap.BeginUpdate;
          LeBitmap.Clear($00FFFFFF);
          Macouleur := Color32(FChoixCat.PanCouleur.Color) and $A0FFFFFF;
          LeBitmap.FillRectS(Rect(Round(XM0),MargeH,X,LeBitmap.Height-MargeB-1),MaCouleur);
          LeBitmap.EndUpdate;
          CoucheProv.Bitmap.Changed;
          Dessin.Changed;
        end
      else if TraceEnCours and PtInRect(RectGraphe,Point(X,Y)) and (LeParam1 <> Nil) and (LeParam2 <> Nil) then
         begin
           LeBitmap := CoucheProv.Bitmap;
           LeBitmap.BeginUpdate;
           LeBitmap.Clear($00FFFFFF);
           Macouleur := Color32(FChoixCat.PanCouleur.Color);
           Polygone.DrawEdge(LeBitmap,Macouleur);
           LeBitmap.LineS(XM0,YM0,X,Y,Macouleur);
           LeBitmap.EndUpdate;
           CoucheProv.Bitmap.Changed;
           Dessin.Changed;
         end;
    end;
{  if (Length(Polygone.Points) > 0) and PtInPolygon(Fixedpoint(X,Y),Polygone.Points[0]) then
    Label4.Caption:='Dedans'
  else
    Label4.Caption:='Dehors';
}
  if PtInRect(RectGraphe,Point(X,Y)) and PInfos.Visible and (LeParam1 <> Nil) and (LeParam2 <> Nil) then
    begin
      Monpoint.X := Round((X-MargeG)/(Dessin.Bitmap.Width-MargeG-MargeD)*(MaxiAxeX)); //-MiniAxeX
      Monpoint.Y := Round(MaxiAxeY-(Y-MargeH)/(Dessin.Bitmap.Height-MargeH-MargeB)*(MaxiAxeY)); //-MiniAxeY
      MonPointC := MonPoint;
      TitreX := LeParam1.Alias;
      if TitreX = '' then
        TitreX := LeParam1.Nom;
      TitreY := LeParam2.Alias;
      if TitreY = '' then
        TitreY := LeParam2.Nom;
      if MLogX.Checked then
        begin
          MPX := 10*Power(10,Monpoint.X/200);
          MonPointC.X := Round(MPX);
          StrCX := FloatToStrF(MPX,ffFixed,8,2);
        end
      else if LeParam1.TypeEchelle = TTypeEchelle.teLog then
        begin
          MPX := Power(10,Monpoint.X*LeParam1.Puis10Log/MesDonneesCyto.Resolution);
          StrCX := FloatToStrF(MPX,ffFixed,8,2);
        end
      else
        StrCX := IntToStr(Round(Monpoint.X));

      if MLogY.Checked then
        begin
          MPY := 10*Power(10,Monpoint.Y/200);
          MonPointC.Y := Round(MPY);
          StrCY := FloatToStrF(MPY,ffFixed,8,2);
        end
      else if LeParam2.TypeEchelle = TTypeEchelle.teLog then
        begin
          MPY := Power(10,Monpoint.Y*LeParam2.Puis10Log/MesDonneesCyto.Resolution);
          StrCY := FloatToStrF(MPY,ffFixed,8,2);
        end
      else
        StrCY := IntToStr(MonPoint.Y);
      LCurseur.Caption :='    '+ TitreX + ' : '+ StrCX +' ; ' + TitreY + ' : '+ StrCY;

      MaCategorie := LaCategorieGraphe(MonPointC,LeParam1,LeParam2,MesDonneesCyto.Resolution);
      if MaCategorie <> Nil then
        begin
          if MaCategorie.CatAnnexe then
            LCat.Caption := MaCategorie.CatFille.Nom
          else
            LCat.Caption := MaCategorie.Nom
        end
      else
        LCat.Caption :='';
    end
  else if PtInRect(RectGraphe,Point(X,Y)) and PInfos.Visible and (LeParam1 <> Nil) and (LeParam2 = Nil) then
    begin
      Monpoint.X := Round((X-MargeG)/(Dessin.Bitmap.Width-MargeG-MargeD)*(MaxiAxeX)); //-MiniAxeX
      MonPointC := MonPoint;
      TitreX := LeParam1.Alias;
      if TitreX = '' then
        TitreX := LeParam1.Nom;
      if MLogX.Checked then
        begin
          MPX := 10*Power(10,Monpoint.X/200);
          MonPointC.x:=Round(MPX);
          StrCX := FloatToStrF(MPX,ffFixed,8,2);
        end
      else if LeParam1.TypeEchelle = TTypeEchelle.teLog then
        begin
          MPX := Power(10,Monpoint.X*LeParam1.Puis10Log/MesDonneesCyto.Resolution);
          StrCX := FloatToStrF(MPX,ffFixed,8,2);
        end
      else
        StrCX := IntToStr(Round(Monpoint.X));
      LCurseur.Caption :='    '+ TitreX + ' : '+ StrCX; //+'Valeur lue : '+IntToStr(MonPoint.x)+' X = '+IntToStr(X);
      MaCategorie := LaCategorieHisto(MonPointC.x,LeParam1,MesDonneesCyto.Resolution);
      if MaCategorie <> Nil then
        begin
          if MaCategorie.CatAnnexe then
            LCat.Caption := MaCategorie.CatFille.Nom
          else
            LCat.Caption := MaCategorie.Nom
        end
      else
        LCat.Caption :='';
    end
  else
    begin
      LCurseur.Caption :='';
      LCat.Caption :='';
    end;
end;

procedure TFGraphe.DessinMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: integer; Layer: TCustomLayer);
Var
  UneCategorie : TCategorie;
  coefX ,VXmin,VXmax,dx,VMax: real;
  larg,NbGX : integer;
  XMmin,XMmax : integer;
  VrXMin,VrXMax : real;
begin
if MAjouterCat.Checked then
  begin
    if (LeParam1 <> Nil) and (LeParam2 = Nil) then
      begin
        FinTrace:=True;       //** Tenir compte de MLogX.Checked
        if XM1 <> XM0 then
          begin
            UneCategorie := TCategorie.Create;
            UneCategorie.Nom := 'Categorie '+ InTToStr(LesCategories.NbCategorieDeBase + 1);
            UneCategorie.NbParams := 1;
            SetLength(UneCategorie.Params,1);
            UneCategorie.Params[0] :=  (ComboParam1.Items.Objects[ComboParam1.ItemIndex] as TPAram);
            UneCategorie.Resolution := UneCategorie.Params[0].Resolution;
            UneCategorie.Active := True;
            CoucheProv.Cursor := CrDefault;
            if CatRestr = nil then
              FChoixCat.initialise(ecAjoutSimple)
            else
              begin
                FChoixCat.CatRestr := CatRestr;
                FChoixCat.initialise(ecAjoutSimpleComp);
                UneCategorie.CatAnnexe:=True;
              end;
            FChoixCat.CatSimpleEnCours := UneCategorie;
            if FChoixCat.ShowModal = mrOK then
              begin
                if MLogX.Checked then
                  coefX :=(MaxiAxeX-200)/(Dessin.Bitmap.Width-MargeG-MargeD)
                else
                  coefX :=MaxiAxeX/(Dessin.Bitmap.Width-MargeG-MargeD);
                UneCategorie.PolygoneDef.Clear;
                // Définir Mini et Maxi
                if XM1 > XM0 then
                  begin
                    XMmin := XM0;
                    XMmax := XM1;
                  end
                else
                  begin
                    XMmin := XM1;
                    XMmax := XM0;
                  end;
                if MLogX.Checked then
                  begin
		    VXmin := Round((XMmin-MargeG)/(Dessin.Bitmap.Width-MargeG-MargeD)*(MaxiAxeX)); // -MiniAxeX
                    VrXMin := 10*Power(10,VXmin/200);
                    UneCategorie.ValeurMin := VrXMin;
		                VXmax := Round((XMmax-MargeG)/(Dessin.Bitmap.Width-MargeG-MargeD)*(MaxiAxeX)); //-MiniAxeX
                    VrXMax := 10*Power(10,VXmax/200);
                    UneCategorie.ValeurMax := VrXMax;
                    if UneCategorie.ValeurMax > UneCategorie.Params[0].Resolution then
                      UneCategorie.ValeurMax := UneCategorie.Params[0].Resolution;
                  end
                else
                  begin
                    UneCategorie.ValeurMin := (XMmin - MargeG)*coefX;
                    if (XMmax - MargeG)*coefX >= MaxiAxeX then
                      UneCategorie.ValeurMax := UneCategorie.Params[0].Resolution
                    else
                      UneCategorie.ValeurMax := (XMmax - MargeG)*coefX;
                  end;
                UneCategorie.Nom := FChoixCat.EditNom.Text;
                UneCategorie.Couleur := Color32(FChoixCat.PanCouleur.Color);
                if CatRestr = nil then
                  UneCategorie.Active := True  //FChoixCat.CheckActive.Checked
                else
                  UneCategorie.Active :=False;
                LesCategories.AjouteDeBase(UneCategorie);
                FChoixCat.Ajouter;
                if CatRestr <> nil then
                  UneCategorie.CatFille:=LesCategories.LesCategoriesComp[LesCategories.NbCategorieComp-1];

                TraceGraphe;
                if Assigned(OnCatChange) then OnCatChange(Self);
              end
            else
              begin
               UneCategorie.Free;
              end;
            CoucheProv.Visible := False;
          end;
        CoucheProv.Bitmap.Clear($00FFFFFF);
        MAjouterCat.Checked := False;
        PInstruct.Visible := False;
        PChoix.Visible := False;
        PChoixTitre.Visible := False;
        PInfos.Visible := True;
        CoucheProv.Visible := False;
      end;
  end;
end;

procedure TFGraphe.FormCreate(Sender: TObject);
Var
  h,w : integer;
begin
  NumSerie := 0;
  RectGraphe := Rect(MargeG,MargeH,Dessin.Width-MargeD,Dessin.Height-MargeB);
  Dessin.Bitmap.Width := Dessin.Width;
  Dessin.Bitmap.Height := Dessin.Height;
  Dessin.Bitmap.Clear($FFFFFFFF);
  Dessin.Bitmap.Font.Size:=9;
  FinTrace:=True;
  Inverser := False;
  TaillePoints := 2;
  Polygone := TPolygon32.Create;
  Polygone.Closed:=False;
  h:=Dessin.Bitmap.Height;
  w:=Dessin.Bitmap.Width;
  CoucheProv:= TBitmapLayer.Create(Dessin.Layers);
  with CoucheProv do
    begin
      Bitmap.DrawMode := dmBlend;
      Bitmap.CombineMode:=cmBlend;
      //Bitmap.MasterAlpha := $A0;
      Scaled:=True;
      Bitmap.SetSize(w,h);
      Location:=FloatRect(0,0,w,h);
      Visible := False;
    end;
  CoucheProv.Bitmap.Clear($00FFFFFF);
  Legende := TBitmapLayer.Create(Dessin.Layers);
  with Legende do
    begin
      Bitmap.DrawMode := dmOpaque;
      Scaled:=True;
      Bitmap.SetSize(0,0);
      Location:=FloatRect(MargeG + 10,MargeH + 10,MargeG + 10,MargeH + 10);
      Visible := False;
      Bitmap.Font.Size := 9;
    end;
  SupportLegende := TRubberbandLayer.Create(Dessin.Layers);
  with SupportLegende do
    begin
      Location:=FloatRect(MargeG + 10,MargeH + 10,MargeG + 10,MargeH + 10);
      Visible := False;
      Handles := [rhCenter];
    end;
  SupportLegende.ChildLayer:=Legende;
end;

procedure TFGraphe.FormResize(Sender: TObject);
begin
  RectGraphe := Rect(MargeG,MargeH,Dessin.Width-MargeD,Dessin.Height-MargeB);
  Dessin.Bitmap.Width := Dessin.Width;
  Dessin.Bitmap.Height := Dessin.Height;
  Dessin.Bitmap.Clear($FFFFFFFF);
  CoucheProv.Bitmap.Width := Dessin.Width;
  CoucheProv.Bitmap.Height := Dessin.Height;
  CoucheProv.Location:= FloatRect(0,0,Dessin.Width,Dessin.Height);
  CoucheProv.Bitmap.Clear($00FFFFFF);
  TraceGraphe;
  FinTrace:=True;
end;

procedure TFGraphe.DessineLegende;
Var
  NbCol,NbLig : integer;
  RectLeg : TRect;
  lgnm,htnm : real;
  LeParametre1,LeParametre2 : TParam;
begin
  if MAfDensite.Checked or ((LeParam1 <> nil) and (LeParam2 = nil)) then
    begin
      LeParametre1 := LeParam1;
      LeParametre2 := LeParam2;
    end
  else if (LeParam2 <> nil) and (LeParam1 <> nil) then
    begin
      LeParametre1 := nil;
      LeParametre2 := nil;
    end
  else
    begin
      Legende.Visible := False;
      SupportLegende.Visible:=False;
      exit;
    end;
  RectLeg := LesCategories.RectangleLegende(Legende.Bitmap,FloatPoint(SupportLegende.Location.Left,SupportLegende.Location.Top),LeParametre1,LeParametre2,MesDonneesCyto,NbCol,NbLig,lgnm,htnm);
  if (RectLeg.Left <> RectLeg.Right) and (RectLeg.Top <> RectLeg.Bottom) then
    begin
      SupportLegende.Visible:=True;
      SupportLegende.Handles:=[rhCenter];
      SupportLegende.Location:=Floatrect(RectLeg);
      Legende.Bitmap.SetSize(RectLeg.Right-RectLeg.Left,RectLeg.Bottom-RectLeg.Top);
      LesCategories.DessineLegende(Legende.Bitmap,FloatPoint(0,0),LeParametre1,LeParametre2,MesDonneesCyto,NbCol,NbLig);
      if NbLig = 0 then
        begin
          Legende.Visible := False;
          SupportLegende.Visible:=False;
          exit;
        end;
      SupportLegende.BringToFront;
      Dessin.Invalidate;
    end
  else
    begin
      Legende.Visible := False;
      SupportLegende.Visible:=False;
    end;
end;

procedure TFGraphe.MAffCatClick(Sender: TObject);
begin
  FChoixCat.initialise(ecConsult);
  FChoixCat.ShowModal;
end;

procedure TFGraphe.MAjoutCompClick(Sender: TObject);
begin
  FChoixCat.initialise(ecAjoutComp);
  if FChoixCat.ShowModal = mrOK then
    begin
      TraceGraphe;
      if Assigned(OnCatChange) then OnCatChange(Self);
    end;
end;

procedure TFGraphe.MAjouterCatClick(Sender: TObject);
begin
  if (LeParam1 <> Nil) then
    begin
      MAjouterCat.Checked := True;
      if (LeParam2 <> Nil) then
        begin
          CoucheProv.Cursor := CrCross;
          LInstructCat.Caption := '  Cliquer sur les angles du polygone de délimitation, puis cliquer avec le bouton droit pour fermer le polygone et terminer';
        end
      else
        begin
          CoucheProv.Cursor := CrIBeam;
          LInstructCat.Caption := '   Délimiter la zone avec la souris sur l''histogramme';
        end;
      PChoix.Visible := False;
      PChoixTitre.Visible := False;
      PInstruct.Visible := True;
      PInfos.Visible := False;
      MChoix.Caption := 'Choix des paramètres';
      CoucheProv.Visible := True;
    end;
end;

procedure TFGraphe.MAugmenterClick(Sender: TObject);
begin
  //MaxAxeX := 0;
  MaxiAxeY := MaxiAxeY/2;
  TraceGraphe;
end;

procedure TFGraphe.MCouleurClick(Sender: TObject);
Var
  LeMenuItem : TMenuItem;
begin
  LeMenuItem := TMenuItem(Sender);
  if LeMenuItem <> nil then
    begin
      LeMenuItem.Checked:= True;
      TraceGraphe;
    end;
end;

procedure TFGraphe.MDiminuerClick(Sender: TObject);
begin
  MaxiAxeY := MaxiAxeY*2;
  TraceGraphe;
end;

procedure TFGraphe.MLogClick(Sender: TObject);
Var
  LeMenuItem : TMenuItem;
begin
  LeMenuItem := TMenuItem(Sender);
  if LeMenuItem <> nil then
    begin
      LeMenuItem.Checked:= Not LeMenuItem.Checked;
      TraceGraphe;
    end;
end;

procedure TFGraphe.MChoixClick(Sender: TObject);
begin
  PInstruct.Visible := False;
  PChoixTitre.Visible := False;
  PChoix.Visible := Not PChoix.Visible;
  if PChoix.Visible then
    MChoix.Caption := 'Curseur et informations'
  else
    MChoix.Caption := 'Choix des paramètres';
  PInfos.Visible := (Not PChoix.Visible);
end;

procedure TFGraphe.MChoixtitreClick(Sender: TObject);
begin
  PChoix.Visible := False;
  PInfos.Visible := False;
  PInstruct.Visible := False;
  PChoixTitre.Visible := True;
end;
function TFGraphe.BitmapCopie : TBitmap32;
begin
  Result := TBitmap32.Create;
  Result.Assign(Dessin.Bitmap);
  if Legende.Visible then
    begin
      Result.BeginUpdate;
      Result.Draw(Round(Legende.Location.Left),Round(Legende.Location.Top),Legende.Bitmap);
      Result.EndUpdate;
      Result.Changed;
    end;
end;

procedure TFGraphe.MCopierClick(Sender: TObject);
Var
  BitmapTemp32 : TBitmap32;
  BitmapTemp : TBitmap;
begin
  BitmapTemp32 := Bitmapcopie;
  BitmapTemp := TBitmap.Create;
  try
    BitmapTemp.Assign(BitmapTemp32);
    BitmapTemp.Canvas.Draw(0,0,BitmapTemp);
    Clipboard.Assign(BitmapTemp);

    Clipboard.Assign(BitmapTemp);
  finally
    Bitmaptemp.Free;
    Bitmaptemp32.Free;
  end;
end;

procedure TFGraphe.MEditerCatClick(Sender: TObject);
begin
  if Assigned(RecenceRestr) then
    RecenceRestr(Self);
  FChoixCat.initialise(ecEditSimple);
  FChoixCat.ShowModal;
  TraceGraphe;
  if Assigned(OnCatChange) then OnCatChange(Self);
end;

procedure TFGraphe.MEnregistrerClick(Sender: TObject);
Var
  BitmapTemp : TBitmap32;
begin
  if SaveDialogGraphe.Execute then
    begin
      BitmapTemp := Bitmapcopie;
      try
        BitmapTemp.SaveToFile(SaveDialogGraphe.FileName);
      finally
        Bitmaptemp.Free;
      end;
    end;
end;

procedure TFGraphe.MFermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFGraphe.MImprimerClick(Sender: TObject);
Var
  BitmapTemp : TBitmap32;
begin
  BitmapTemp := Bitmapcopie;
  try
    FGestImp.Imprime(BitmapTemp);
  finally
    Bitmaptemp.Free;
  end;
end;

procedure TFGraphe.MPointMoinsClick(Sender: TObject);
begin
  if TaillePoints > 1 then
    begin
      dec(TaillePoints);
      TraceGraphe;
    end;
end;

procedure TFGraphe.MPointPlusClick(Sender: TObject);
begin
  if TaillePoints > 0 then
    begin
      inc(TaillePoints);
      TraceGraphe;
    end;
end;

procedure TFGraphe.MStatsClick(Sender: TObject);
begin
  FStats.CatRestr := CatRestr;
  FStats.AfficheStats;
  if FStats.WindowState=wsMinimized then
    FStats.WindowState:=wsNormal;
  FStats.Show;
  FStats.BringToFront;
end;

procedure TFGraphe.MSurDessusClick(Sender: TObject);
begin
  MSurDessus.Checked:=Not MSurDessus.Checked;
  if MSurDessus.Checked then
    FormStyle := fsStayOnTop
  else
    FormStyle := fsNormal;
end;

end.


