// Based on 25 Aug 1999 borland.public.delphi.objectpascal newsgroup
// by Bob Lee, who is a Delphi optimization expert

// Bob's posting:
// "I suspected that this was the issue but I wasn't sure.  The underlying
// tidbit you need is an assembler instruction called 'bswap' that reverses
// the bytes in a 32bit quantity.  Here's a collection of Swap routines.
// You'll note that many are the same except for the typing of the
// params/result.  Also I assume that you pass the backwards version
// essentially as untyped DWords."


UNIT SwapLibrary;

{$MODE Delphi}

INTERFACE

  function Swap2(a:cardinal):word;
  function Swap4(a:cardinal):cardinal;
  function Swap4Signed(a:cardinal):longint;
  procedure SwapDoubleTo8(const a:double; var b:double);
  function Swap8ToDouble(var a:double):double;

IMPLEMENTATION

  function Swap2(a:cardinal):word;
  asm
    bswap eax
    shr eax,16
  end;


  function Swap4(a:cardinal):cardinal;
  asm
    bswap eax
  end;


  function Swap4Signed(a:cardinal):longint;
  asm
    bswap eax
  end;


  procedure SwapDoubleTo8(const a:double; var b:double);
  asm
    mov edx,dword ptr[a]
    mov ecx,dword ptr[a+4]
    bswap edx
    bswap ecx
    mov dword ptr [eax],ecx
    mov dword ptr [eax+4],edx
  end;


  function Swap8ToDouble(var a:double):double;
  var
    hold:double;
  asm
    mov edx,dword ptr[eax]
    mov ecx,dword ptr[eax+4]
    bswap edx
    bswap ecx
    mov dword ptr [hold],ecx
    mov dword ptr [hold+4],edx
    fld hold;
  end;


END.
